<?php
/**
 * Publications Model for Publications Component
 *
 * @package    Publications
 * components/com_publications/publications.php
 * @link http://www.icsr.agh.edu.pl/~polak/skrypty/publications.var
 * @license    GNU/GPL
 */


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

/**
 * Publications Model
 *
 * @package    Publications
 */

class PublicationsModelPublications extends JModel {
  var $_dataC;
  var $_dataY;
  var $_dataS;
  
  /**
   * Returns the query
   * @return string The query to be used to retrieve an id of a category titled '$publications_title'
   */
  function  _buildCategoriesQuery(){
    //get a value of the $publications_title variable from a config file
    require(JPATH_COMPONENT_ADMINISTRATOR.DS.'publications_settings.php');
    $database =& JFactory::getDBO();
    //Escape characters with special meaning for the database. 
    $publications_title=$database->getEscaped($publications_title);
    $query = "SELECT * FROM #__categories WHERE title = '$publications_title'";
    return $query;
  }
  
  
  /**
   * Retrieves the category id
   * @return array Array of objects containing the id
   */
  function getCategories() {
    // Lets load the data if it doesn't already exist
    if (empty( $this->_dataC )) {
      $query = $this->_buildCategoriesQuery();
      $this->_dataC = $this->_getList( $query );
    }
    return $this->_dataC;
  }
  
  /**
   * Returns the query
   * @return string The query to be used to retrieve years of publications
   */
  function  _buildYearsQuery(){
    //get a value of the $publications_title variable from a config file
    require(JPATH_COMPONENT_ADMINISTRATOR.DS.'publications_settings.php');
    //get category id
    $items=$this->getCategories();
    $id=$items[0]->id;
    $query = "SELECT * FROM #__content WHERE catid=$id  ORDER BY title DESC";
    return $query;
  }
  
  /**
   * Retrieves the years
   * @return array Array of objects containing years 
   */
  function getYears(){
    if (empty( $this->_dataY )) {
      $query = $this->_buildYearsQuery();
      $this->_dataY = $this->_getList( $query );
    }
    return $this->_dataY;  
  }
  
  /**
   * Returns the query
   * @return string The query to be used to retrieve items which were published in selected year or get all publications
   */
  function _buildSearchQuery() {
    //get a value of the $publications_title variable from a config file
    require(JPATH_COMPONENT_ADMINISTRATOR.DS.'publications_settings.php');
    //get category id
    $items=$this->getCategories();
    $id=$items[0]->id;
    $database =& JFactory::getDBO();
    //determine if all publications should be searched or  publications for selected year only
    $year=JRequest::getVar('year');
    if(strcmp("$year",'all')){
      //get items published in $year
      $year=$database->getEscaped($year);
      $query = "SELECT * FROM #__content WHERE catid=$id AND title = '$year'";
    }
    else {
      //get all publications (for all years)
      $order=$database->getEscaped(JRequest::getVar('order'));
      $query = "SELECT * FROM #__content WHERE catid=$id ORDER BY title $order";
    }
    return $query;
    
  }
  
  /**
   * Retrieves the publications
   * @return array Array of objects containing publications
   */
  function getSearch(){
    if (empty( $this->_dataS )) {
      $query = $this->_buildSearchQuery();
      $this->_dataS = $this->_getList( $query );
    }
    return $this->_dataS;  
  }
}
